/**
*** \file preferences_test_preferences.cpp
*** \brief Class 'PREFERENCES_C' unit test file.
*** \details Unit test file for the 'PREFERENCES_C' class.
**/

/*
** This file is part of moonphase.
** Copyright (C) 2014-2023 Alan Wise <awisesoftware@gmail.com>.
**
** This program is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation, either version 3 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/


/**
*** \internal
*** \brief preferences_test_preferences.cpp identifier.
*** \details Identifier for preferences_test_preferences.cpp.
*** \endinternal
**/
#define   PREFERENCES_TEST_PREFERENCES_CPP


/****
*****
***** INCLUDES
*****
****/


/****
*****
***** DEFINES
*****
****/


/****
*****
***** DATA TYPES
*****
****/


/****
*****
***** CLASSES
*****
****/


/****
*****
***** PROTOTYPES
*****
****/


/****
*****
***** DATA
*****
****/


/****
*****
***** VARIABLES
*****
****/


/****
*****
***** FUNCTIONS
*****
****/


/****
*****
***** TESTS
*****
****/

BOOST_AUTO_TEST_SUITE(Class__PREFERENCES)
  BOOST_AUTO_TEST_SUITE(Function__DefaultConstructor)
    BOOST_AUTO_TEST_CASE(Test_00)
    {
      std::unique_ptr<PREFERENCES_C> pPreferences;


      pPreferences.reset(new PREFERENCES_C());

      BOOST_CHECK(pPreferences.get()!=nullptr);

      delete pPreferences.release();
    }
  BOOST_AUTO_TEST_SUITE_END()
  BOOST_AUTO_TEST_SUITE(Function__GetApplicationPreferencesPointer)
    BOOST_AUTO_TEST_CASE(Test_00)
    {
      PREFERENCES_C Preferences;


      BOOST_CHECK(Preferences.GetApplicationPreferencesPointer()!=nullptr);
    }
  BOOST_AUTO_TEST_SUITE_END()
  BOOST_AUTO_TEST_SUITE(Function__GetMoonDataPreferencesPointer)
    BOOST_AUTO_TEST_CASE(Test_00)
    {
      PREFERENCES_C Preferences;


      BOOST_CHECK(Preferences.GetMoonDataPreferencesPointer()!=nullptr);
    }
  BOOST_AUTO_TEST_SUITE_END()
  BOOST_AUTO_TEST_SUITE(Function__Load)
  BOOST_AUTO_TEST_CASE_EXPECTED_FAILURES(Test_00,1)
    BOOST_AUTO_TEST_CASE(Test_00)
    {
      PREFERENCES_C Preferences;


//      Preferences.Load();
      BOOST_CHECK(false);
    }
  BOOST_AUTO_TEST_SUITE_END()
  BOOST_AUTO_TEST_SUITE(Function__Save)
    BOOST_AUTO_TEST_CASE(Test_00)
    {
      PREFERENCES_C Preferences;


      try
      {
        Preferences.Save();
        BOOST_CHECK(false);
      }
      catch(...)
      {
        BOOST_CHECK(true);
      }
    }
  BOOST_AUTO_TEST_SUITE_END()
BOOST_AUTO_TEST_SUITE_END()

#undef    PREFERENCES_TEST_PREFERENCES_CPP


/**
*** preferences_test_preferences.cpp
**/
