/**
*** \file commontypes_stub.cpp
*** \brief Module 'commontypes' stub implementation file.
*** \details Stub implementation file for the 'commontypes' module.
**/

/*
** This file is part of moonphase.
** Copyright (C) 2014-2023 Alan Wise <awisesoftware@gmail.com>.
**
** This program is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation, either version 3 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/


/**
*** \internal
*** \brief commontypes_stub.cpp identifier.
*** \details Identifier for commontypes_stub.cpp.
*** \endinternal
**/
#define   COMMONTYPES_STUB_CPP


/****
*****
***** INCLUDES
*****
****/

#include  "commontypes.h"
//#ifdef    DEBUG_COMMONTYPES_STUB_CPP
//#ifndef   USE_DEBUGLOG
//#define   USE_DEBUGLOG
//#endif    /* USE_DEBUGLOG */
//#endif    /* DEBUG_COMMONTYPES_STUB_CPP */
//#include  "debuglog.h"
//#include  "messagelog.h"

#include  "sysdefs.h"

#include  <limits>
//#include  <stdexcept>


/****
*****
***** DEFINES
*****
****/


/****
*****
***** DATA TYPES
*****
****/


/****
*****
***** CLASSES
*****
****/


/****
*****
***** PROTOTYPES
*****
****/


/****
*****
***** DATA
*****
****/

/**
*** \brief Invalid color component.
*** \details Indicates that a color component is invalid.
**/
float const COLOR_C::mc_Invalid=-1.0;

//float const COLOR_C::mc_Minimum=0.0;

//float const COLOR_C::mc_Maximum=1.0;

int const FONT_C::mc_Invalid=-1;

/**
*** \brief Invalid position value.
*** \details Indicates that a position value is invalid.
**/
int const POSITION_C::mc_Invalid=std::numeric_limits<int>::min();

//int const POSITION_C::mc_Minimum=std::numeric_limits<int>::min()/2;

//int const POSITION_C::mc_Maximum=std::numeric_limits<int>::max()/2;

/**
*** \brief Invalid size value.
*** \details Indicates that a size value is invalid.
**/
int const SIZE_C::mc_Invalid=std::numeric_limits<int>::min();

//int const SIZE_C::mc_Minimum=0;

//int const SIZE_C::mc_Maximum=std::numeric_limits<int>::max();


/****
*****
***** VARIABLES
*****
****/


/****
*****
***** FUNCTIONS
*****
****/

COLOR_C::COLOR_C(void)
{
  return;
}

COLOR_C::COLOR_C(float Red,float Green,float Blue,float Alpha)
{
  UNUSED(Red);
  UNUSED(Green);
  UNUSED(Blue);
  UNUSED(Alpha);

  return;
}

COLOR_C::~COLOR_C(void)
{
  return;
}

COLOR_C & COLOR_C::operator=(COLOR_C const &Color) noexcept
{
  UNUSED(Color);

  return(*this);
}

bool COLOR_C::operator==(COLOR_C const &Color) const
{
  UNUSED(Color);

  return(false);
}

bool COLOR_C::operator!=(COLOR_C const &Color) const
{
  UNUSED(Color);

  return(false);
}

float COLOR_C::GetAlpha(void) const
{
  return(mc_Invalid);
}

float COLOR_C::GetBlue(void) const
{
  return(mc_Invalid);
}

float COLOR_C::GetGreen(void) const
{
  return(mc_Invalid);
}

float COLOR_C::GetRed(void) const
{
  return(mc_Invalid);
}

void COLOR_C::Invalidate(void)
{
  return;
}

bool COLOR_C::IsValid(void) const
{
  return(false);
}

void COLOR_C::SetAlpha(float Alpha)
{
  UNUSED(Alpha);

  return;
}

void COLOR_C::SetBlue(float Blue)
{
  UNUSED(Blue);

  return;
}

void COLOR_C::SetGreen(float Green)
{
  UNUSED(Green);

  return;
}

void COLOR_C::SetRed(float Red)
{
  UNUSED(Red);

  return;
}

void COLOR_C::SetRGBA(float Red,float Green,float Blue,float Alpha)
{
  UNUSED(Red);
  UNUSED(Green);
  UNUSED(Blue);
  UNUSED(Alpha);

  return;
}

FONT_C::FONT_C(void)
{
  return;
}

FONT_C::FONT_C(
    std::string const &Family,int PointSize,int Weight,bool ItalicFlag)
{
  UNUSED(Family);
  UNUSED(PointSize);
  UNUSED(Weight);
  UNUSED(ItalicFlag);

  return;
}

FONT_C::~FONT_C(void)
{
  return;
}

bool FONT_C::operator==(FONT_C const &Font) const
{
  UNUSED(Font);

  return(false);
}

bool FONT_C::operator!=(FONT_C const &Font) const
{
  UNUSED(Font);

  return(false);
}

std::string FONT_C::GetFamily(void) const
{
  return("");
}

bool FONT_C::GetItalicFlag(void) const
{
  return(false);
}

int FONT_C::GetPointSize(void) const
{
  return(mc_Invalid);
}

int FONT_C::GetWeight(void) const
{
  return(mc_Invalid);
}

void FONT_C::Invalidate(void)
{
  return;
}

bool FONT_C::IsValid(void) const
{
  return(false);
}

void FONT_C::SetFamily(std::string const &Family)
{
  UNUSED(Family);

  return;
}

void FONT_C::SetItalicFlag(bool ItalicFlag)
{
  UNUSED(ItalicFlag);

  return;
}

void FONT_C::SetPointSize(int PointSize)
{
  UNUSED(PointSize);

  return;
}

void FONT_C::SetWeight(int Weight)
{
  UNUSED(Weight);

  return;
}

POSITION_C::POSITION_C(void)
{
  return;
}

POSITION_C::POSITION_C(int X,int Y)
{
  UNUSED(X);
  UNUSED(Y);

  return;
}

POSITION_C::~POSITION_C(void)
{
  return;
}

bool POSITION_C::operator==(POSITION_C const &Position) const
{
  UNUSED(Position);

  return(false);
}

bool POSITION_C::operator!=(POSITION_C const &Position) const
{
  UNUSED(Position);

  return(false);
}

int POSITION_C::GetX(void) const
{
  return(mc_Invalid);
}

int POSITION_C::GetY(void) const
{
  return(mc_Invalid);
}

void POSITION_C::Invalidate(void)
{
  return;
}

bool POSITION_C::IsValid(void) const
{
  return(false);
}

void POSITION_C::SetX(int X)
{
  UNUSED(X);

  return;
}

void POSITION_C::SetXY(int X,int Y)
{
  UNUSED(X);
  UNUSED(Y);

  return;
}

void POSITION_C::SetY(int Y)
{
  UNUSED(Y);

  return;
}

SIZE_C::SIZE_C(void)
{
  return;
}

SIZE_C::SIZE_C(int Width,int Height)
{
  UNUSED(Width);
  UNUSED(Height);

  return;
}

SIZE_C::~SIZE_C(void)
{
  return;
}

bool SIZE_C::operator==(SIZE_C const &Size) const
{
  UNUSED(Size);

  return(false);
}

bool SIZE_C::operator!=(SIZE_C const &Size) const
{
  UNUSED(Size);

  return(false);
}

int SIZE_C::GetHeight(void) const
{
  return(mc_Invalid);
}

int SIZE_C::GetWidth(void) const
{
  return(mc_Invalid);
}

void SIZE_C::Invalidate(void)
{
  return;
}

bool SIZE_C::IsValid(void) const
{
  return(false);
}

void SIZE_C::SetHeight(int Height)
{
  UNUSED(Height);

  return;
}

void SIZE_C::SetWidth(int Width)
{
  UNUSED(Width);

  return;
}

void SIZE_C::SetWidthHeight(int Width,int Height)
{
  UNUSED(Width);
  UNUSED(Height);

  return;
}


#undef    COMMONTYPES_STUB_CPP


/**
*** commontypes_stub.cpp
**/
