/**
*** \file moondata_stub.c
*** \brief Module 'moondata' stub implementation file.
*** \details Stub implementation file for the 'moondata' module.
**/

/*
** This file is part of moonphase.
** Copyright (C) 2014-2023 Alan Wise <awisesoftware@gmail.com>.
**
** This program is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation, either version 3 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/


/**
*** \internal
*** \brief moondata_stub.cpp identifier.
*** \details Identifier for moondata_stub.cpp.
*** \endinternal
**/
#define   MOONDATA_STUB_C


/****
*****
***** INCLUDES
*****
****/

#include  "moondata.h"

#include  "sysdefs.h"


/****
*****
***** DEFINES
*****
****/


/****
*****
***** DATA TYPES
*****
****/


/****
*****
***** PROTOTYPES
*****
****/


/****
*****
***** DATA
*****
****/


/****
*****
***** VARIABLES
*****
****/

static float f_MoonPhasePercent;


/****
*****
***** FUNCTIONS
*****
****/

float MoonData_GetMoonPhasePercent(MOONDATA_T const *pMoonData)
{
  UNUSED(pMoonData);

  return(f_MoonPhasePercent);
}

//void MoonData_Recalculate(MOONDATA_T *pMoonData,time_t GMTt)
//{
//  return;
//}

void MoonDataStub_SetMoonPhasePercent(float Percent)
{
  f_MoonPhasePercent=Percent;

  return;
}


#undef    MOONDATA_STUB_C


/**
*** moondata_stub.c
**/
