/**
*** \file moondata_stub.h
*** \brief
*** \details
**/

/*
** This file is part of moonphase.
** Copyright (C) 2014-2023 Alan Wise <awisesoftware@gmail.com>.
**
** This program is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation, either version 3 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/


#if       !defined(MOONDATA_STUB_H)
/**
*** \internal
*** \brief moondata_stub.h identifier.
*** \details Identifier for moondata_stub.h.
*** \endinternal
**/
#define   MOONDATA_STUB_H


/****
*****
***** INCLUDES
*****
****/


/****
*****
***** DEFINES
*****
****/


/****
*****
***** DATA TYPES
*****
****/


/****
*****
***** CLASSES
*****
****/


/****
*****
***** DATA
*****
****/


/****
*****
***** VARIABLES
*****
****/


/****
*****
***** PROTOTYPES
*****
****/

#if       defined(__cplusplus)
extern "C" {
#endif    /* defined(__cplusplus) */

/**
*** \brief Returns the moon phase percent.
*** \details Returns the moon phase as a percent [0,100).
*** \param pMoonData Calculated moon data.
*** \returns The moon phase as a percent [0,100).
**/
void MoonDataStub_SetMoonPhasePercent(float Percent);

#if       defined(__cplusplus)
}
#endif    /* defined(__cplusplus) */


#endif    /* !defined(MOONDATA_STUB_H) */


/**
*** moondata_stub.h
**/
