/**
*** \file preferencesmanager_stub.h
*** \brief
*** \details
**/

/*
** This file is part of moonphase.
** Copyright (C) 2014-2023 Alan Wise <awisesoftware@gmail.com>.
**
** This program is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation, either version 3 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/


#if       !defined(PREFERENCESMANAGER_STUB_H)
/**
*** \internal
*** \brief preferencesmanager_stub.h identifier.
*** \details Identifier for preferencesmanager_stub.h.
*** \endinternal
**/
#define   PREFERENCESMANAGER_STUB_H


/****
*****
***** INCLUDES
*****
****/

#include  <string>
#include  <vector>


/****
*****
***** DEFINES
*****
****/


/****
*****
***** DATA TYPES
*****
****/


/****
*****
***** CLASSES
*****
****/


/****
*****
***** DATA
*****
****/


/****
*****
***** VARIABLES
*****
****/


/****
*****
***** PROTOTYPES
*****
****/

#if       defined(__cplusplus)
extern "C" {
#endif    /* defined(__cplusplus) */

#if       defined(__cplusplus)
}
#endif    /* defined(__cplusplus) */

void PreferencesManagerStub_ClearPreferences(void);
std::vector<std::string> const & PreferencesManagerStub_GetGroupList(void);
void PreferencesManagerStub_GetPreference(std::string const &Key,bool &Value);
void PreferencesManagerStub_GetPreference(std::string const &Key,COLOR_C &Value);
void PreferencesManagerStub_GetPreference(std::string const &Key,std::string &Value);
void PreferencesManagerStub_SetPreference(std::string const &Key,bool Value);
void PreferencesManagerStub_SetPreference(std::string const &Key,char const *pValue);
void PreferencesManagerStub_SetPreference(std::string const &Key,COLOR_C const &Value);
void PreferencesManagerStub_SetPreference(std::string const &Key,std::string const &Value);
void PreferencesManagerStub_SetPreference(
    std::string const &Key,std::string const &Value);


#endif    /* !defined(PREFERENCESMANAGER_STUB_H) */


/**
*** preferencesmanager_stub.h
**/

