#!/bin/bash

RCFILE=/root/.pbuilderrc-moonphase

# Command line options for "pbuilder".
PBUILDER_OPT='--distribution ${DIST} --architecture ${ARCH} --basetgz ~/moonphase-${DIST}-${ARCH}.tgz --configfile ${RCFILE}'

# Create .pbuilderrc file.
PBUILDERRCTEMP=$(mktemp moonphase-XXXXXXXXXX)
echo 'DEBOOTSTRAPOPTS="--keyring=/usr/share/keyrings/debian-archive-keyring.gpg"'  >>${PBUILDERRCTEMP}
echo 'MIRRORSITE=https://mirrors.kernel.org/debian/' >>${PBUILDERRCTEMP}
# Cache dependencies so they are not downloaded EVERY time.
echo 'EXTRAPACKAGES="fakeroot debhelper cmake git libcurl4-openssl-dev ninja-build qtbase5-dev"' >>${PBUILDERRCTEMP}
    # fakeroot needed by pbuilder, git needed by .gitlab-ci.yml.
    # All others by moonphase.
sudo mv ${PBUILDERRCTEMP} ${RCFILE}

# Create the x86_64 environment.
DIST="bookworm"
ARCH="amd64"
sudo pbuilder create $(eval echo $PBUILDER_OPT)

# Clean up.
sudo pbuilder clean
sudo rm ${RCFILE}
