#!/bin/bash

# Check if in project root.
if [ ! -d "./shell" ]; then
  Msg="this script must be run from the project root directory."
fi

if [ "$Msg" == "" ]; then
  # Remove "old" build directory.
  rm -rf .build >/dev/null

  # Create build directory.
  mkdir .build
  if [ $? -ne 0 ]; then
    Msg="unable to create build directory."
  else
    # Change to build directory.
    pushd .build >/dev/null
    if [ $? -ne 0 ]; then
      Msg="unable to change to build directory."
    else
      # Configure the build. (Defaults to "Release").
      cmake -G "Ninja"  ..
      if [ $? -ne 0 ]; then
        Msg="unable to configure build."
      else
        # Perform the build.
        ninja
        if [ $? -ne 0 ]; then
          Msg="unable to build."
        fi
      fi
      popd
    fi
  fi
fi
if [ "$Msg" != "" ]; then
  echo -e "Error: $Msg"
  exit 1
fi
