#!/bin/bash

# $1 - Project directory (required).
# $2 - Project (required).
# $3 - Version (required).
# $4 - Distribution (unused).
# $5 - Architecture (required).

if [ "$#" -ne "5" ]; then
  if [ "$#" -lt "5" ]; then
    echo "Error: missing parameters."
  else
    echo "Error: extra parameters."
  fi

  echo "Usage: $0 [projectdir] [projectname] [projectversion] [distribution] [x86_64]"
  exit 1
fi

# Make script easier to read.
ProjDir="$1"
Project="$2"
Version="$3"
Dist="$4"
Arch="$5"

if [ "$Arch" != "x86_64" ]; then
  echo "Error: invalid architecture (use 'x86_64')."
  exit 1
fi

# Create macOS package.
export PATH=$PATH:/usr/local/Cellar/qt@5/5.15.8_2/bin
shell/build-macos.sh &&
cd .build/qt/moonphase-qt &&
macdeployqt moonphase-qt.app &&
mv moonphase-qt.app "Moon Phase (Qt).app" &&
pkgbuild --install-location /Applications --component "Moon Phase (Qt).app" moonphase-qt.pkg &&
productbuild --distribution ../../../package/macos/distribution.xml --resources ../../../documentation moonphase-qt-0.6.0.pkg
cd "${ProjDir}"
